#ifndef _PROTOCOL_
#define _PROTOCOL_

enum DIRECTION {
	UP,
	DOWN,
	LEFT,
	RIGHT
};

enum CLIENTPACKET {
	C_MOVE,		// char direction
	C_SAY,		// short length
				// char[] string
	C_ATTACK,	// victim id
	C_NAME,
	C_MAX
};

enum SERVERPACKET {
	S_MOVE,		// int user id
				// char direction
	S_REMOVE,	// int user id
	S_SAY,		// int user id
				// char[] string
	S_ATTACK,	// int user id
				// int victim id
	S_ENTER,	// int user
				// char[] name
	S_LOG,		// char[] log
	S_NAME,
	S_MAX
};
#endif
