#include <windows.h>
#include <stdio.h>
#include <stdarg.h>
#include "user.h"
#include "protocol.h"
#include "server.h"
#include "util.h"
#include "string.h"

User::User(SOCKET hSocket)
{
	m_hSocket = hSocket;
	m_nId = 0;
	m_nLevel = 1;
	m_nHP = 5;
	m_pszName = NULL;
	m_bAlive = true;
	m_nX = 0;
	m_nY = 0;
	m_bClosed = false;
	m_nExp = 0;
}

void User::Packet(char* pPacket)
{
	switch (*pPacket++) {
	case C_MOVE :
		if (IsAlive() == true) {
			g_world.Move(this, (char) *pPacket);
		}
		break;
	case C_SAY :
		{
			char szBuffer[1024];

			GetString(pPacket, szBuffer, sizeof(szBuffer));
			g_world.Say(this, szBuffer);
		}
		break;
	case C_ATTACK :
		{
			if (IsAlive() == true) {
				unsigned int nVictim;
				
				GetInteger(pPacket, (int&) nVictim);
				g_world.Attack(this, nVictim);
			}
		}
		break;
	case C_NAME :
		{
			char szBuffer[1024];

			GetString(pPacket, szBuffer, sizeof(szBuffer));
			SetName(szBuffer);
			g_world.Enter(this);
		}
	}
}

void User::Send(char* pPacket,int nPacket)
{
	send(m_hSocket, (const char*) pPacket, nPacket, 0);
}

void User::Damage(User* pAttacker)
{
	int nDamage = pAttacker->Level();

	m_nHP -= nDamage;
	Log("'%s'   %d ظ Ծϴ.", pAttacker->Name(), nDamage);
	if (m_nHP <= 0) {
		SetAlive(false);
		Log("¾ ߽ϴ :)");
		pAttacker->Exp(Level());
	}
}

void User::Exp(int nExp)
{
	m_nExp += nExp;

	if (m_nExp >= (Level() + 1) * (Level() + 1)) {
		m_nLevel++;
		m_nHP += Level() * Level();
	}
}

void User::Log(const char* pszFormat, ...)
{
	char szBuffer[512];
	va_list	pArg;

	va_start(pArg, pszFormat);
	vsprintf(szBuffer, pszFormat, pArg);
	va_end(pArg);

	char szPacket[1024];
	char* pPacket = szPacket + 2;

	pPacket = SetChar(pPacket, S_LOG);
	pPacket = SetString(pPacket, szBuffer);
	SetShort(szPacket, pPacket - szPacket);
	Send(szPacket, pPacket - szPacket);
}

void User::Send(char cPacket)
{
	char szPacket[4];

	SetShort(szPacket, 3);
	SetShort(szPacket + 2, cPacket);
	send(m_hSocket, (const char*) szPacket, 3, 0);
}

void User::AddRef()
{
}

void User::Release()
{
}
