#ifndef _USER_
#define _USER_

class User {
protected:
	SOCKET m_hSocket;
	unsigned int m_nId;
	int m_nLevel;
	int m_nHP;
	char* m_pszName;
	bool m_bAlive;
	int m_nX;
	int m_nY;
	bool m_bClosed;
	int m_nExp;
public:
	User(SOCKET hSocket);

	void Send(char* pPacket,int nPacket);
	void Packet(char* pPacket);
	void Log(const char* pszFormat, ...);
	void Damage(User* pUser);
	int X() { return m_nX; }
	int Y() { return m_nY; }
	void SetX(int nX) { m_nX = nX; }
	void SetY(int nY) { m_nY = nY; }
	unsigned int Id() { return m_nId; }
	char* Name() { return m_pszName; }
	void SetName(char *pszName) { m_pszName = _strdup(pszName); }
	void AddRef();
	void Release();
	void Send(char cPacket);
	void SetId(unsigned int nId) { m_nId = nId; }
	bool Closed() { return m_bClosed; }
	SOCKET Socket() { return m_hSocket; }
	bool IsAlive() { return m_bAlive; }
	void SetAlive(bool bAlive) { m_bAlive = bAlive; }
	int Level() { return m_nLevel; }
	void Exp(int nLevel);
};
#endif
