#ifndef _WORLD_
#define _WORLD_

class User;

class World {
protected:
	CRITICAL_SECTION m_csUser;
	CRITICAL_SECTION m_csWorld;
	std::map<unsigned int,User*> m_mapUser;
	unsigned int m_nId;
public:
	World();
	~World();

	bool MoveUser(User* pUser,char cDirection);
	void Move(User* pUser,char cDirection);
	void Say(User* pUser,char* pszSay);
	void Attack(User* pAttacker,unsigned int nVictim);
	void Send(char* pPacket,int nPacket);
	User* FindUser(unsigned int nId);
	void Enter(User* pUser);
	void AddUser(User* pUser);
	void Remove(User* pUser);
};

#endif
