#include <string.h>
#include "util.h"

char* GetShort(char* pPacket,short& sNum)
{
	sNum = *pPacket + (*(pPacket + 1) << 8);
	return pPacket + 2;
}

char* GetInteger(char* pPacket,int& nNum)
{
	nNum = pPacket[0] + (pPacket[1] << 8) + (pPacket[2] << 16) + (pPacket[3] << 24);
	return pPacket + 4;
}

char* GetString(char* pPacket,char* pszBuffer,int nBuffer)
{
	short sLength;

	pPacket = GetShort(pPacket, sLength);
	strncpy(pszBuffer, pPacket, sLength);
	*(pszBuffer + sLength) = NULL;
	return pPacket + sLength;
}

char* SetInteger(char* pPacket,int nI)
{
	*pPacket++ = nI;
	*pPacket++ = nI >> 8;
	*pPacket++ = nI >> 16;
	*pPacket++ = nI >> 24;
	return pPacket;
}

char* SetShort(char* pPacket,short sShort)
{
	*pPacket++ = (char) sShort;
	*pPacket++ = sShort >> 8;
	return pPacket;
}

char* SetChar(char* pPacket,char cCh)
{
	*pPacket++ = cCh;
	return pPacket;
}

char* SetString(char* pPacket,char* pszSay)
{
	pPacket = SetShort(pPacket, strlen(pszSay));
	memcpy(pPacket, pszSay, strlen(pszSay));
	return pPacket + strlen(pszSay);
}
